//////  Balony   //////


#include <iostream.h>


const int min_pkt = 3;

class Pionek;

class Pole
{
public:
	int x;
	int y;
	Pole()
	{
		x = y = 0;
	}
};


class Pionek
{

protected:
	char Nazwa[2];
	int Punkty;

public:

	Pole Pozycja;
	
	Pionek(int x, int y, char nazwa[ ])
	{
		Nazwa[0] = *nazwa;
		Nazwa[1] = 0;
	
		Pozycja.x = x;
		Pozycja.y = y;

		Punkty = 0;
	}
	Pionek(){}


	void Gora()
	{
		if (Pozycja.y > 0 && Punkty >= min_pkt )
		{
			Pozycja.y--;
			Punkty -= min_pkt;
		}
	}

	void Dol()
	{
		if (Pozycja.y < 7 && Punkty >= min_pkt)
		{
			Pozycja.y++;
			Punkty -= min_pkt;
		}
	}

	void Lewo()
	{
		if (Pozycja.x > 0 && Punkty >= min_pkt)
		{
			Pozycja.x--;
			Punkty -= min_pkt;
		}
	}

	void Prawo()
	{
		if (Pozycja.x < 5 && Punkty >= min_pkt)
		{
			Pozycja.x++;
			Punkty -= min_pkt;
		}
	}

	void Rysuj()
	{
		cout << Nazwa << Punkty << '|' ;
	}

	void Zmiana(int nowe)
	{
		if (nowe >= 1 && nowe <= 6)
			Punkty += nowe;
	}

	void Zeruj()
	{
		Punkty = 0;
	}

	int Ile()
	{
		return Punkty;
	}



};



class Balon : protected Pionek
{

public:
	Pionek::Gora;
	Pionek::Rysuj;
	Pionek::Zmiana;
	Pionek::Zeruj;
	Pionek::Ile;
	Pionek::Pozycja;

	Balon(int x, int y, char nazwa[ ]);
	
	
};

Balon::Balon(int x, int y, char nazwa[ ]) : Pionek(x, y, nazwa)
{ }

class Tarcza : public Pionek
{
public:
	Tarcza(int x, int y, char nazwa[ ]) : 
		Pionek(x, y, nazwa)
	{}

};


class Rozgrywka
{
	Pionek* Plansza[8][6];

	Balon* Balony[6];
	Tarcza* Tarcze[2];
	
	void Rysuj();
	bool Rzut(bool kto);
	void RuchBalonu(int nr);
	void RuchTarczy(int nr);

public:
	void Graj();
};

void Rozgrywka::Graj()
{
	int i, j;
	char nazwa[2] = "a";
	bool kto = true;	// true - lewy, false - prawy
	
	for (i = 0 ; i < 8 ; i++)
		for (j = 0 ; j < 6 ; j++)
			Plansza[i][j] = NULL;

	for (i = 0 ; i < 3 ; i++)
	{
		Balony[i] = new Balon(i, 7, nazwa);
		Plansza[7][i] = (Pionek*)Balony[i];
		nazwa[0]++;
	}

	nazwa[0] = 'x';
	for (i = 3 ; i < 6 ; i++)
	{
		Balony[i] = new Balon(i, 7, nazwa);
		Plansza[7][i] = (Pionek*)Balony[i];
		nazwa[0]++;
	}

	nazwa[0] = 'P';
	Tarcze[0] = new Tarcza(0, 3, nazwa);
	Plansza[3][0] = Tarcze[0];

	nazwa[0] = 'L';
	Tarcze[1] = new Tarcza(5, 3, nazwa);
	Plansza[3][5] = Tarcze[1];

	Rysuj();

	while (true)
		if (kto)
		{							// lewy
			if (Rzut(kto))
			{
				cout << "Lewy wygral !" << endl;
				return;
			}
			else
				kto = ! kto;
		}
		else
		{							// prawy
			if (Rzut(kto))
			{
				cout << "Prawy wygral !" << endl;
				return;
			}
			else	
				kto = ! kto;
		}

}

void Rozgrywka::Rysuj()
{
	int i, j;

	for (i = 0; i < 8; i++)
	{
		cout << endl << "    ";
		for (j = 0; j < 18; j++)
			cout << '-';
		
		cout << endl << "   |";
		for (j = 0; j < 3; j++)
			if (Plansza[i][j] != NULL)
				Plansza[i][j]->Rysuj();
			else
				cout << "  |";
		
		cout << '|';

		for (j = 3; j < 6; j++)
			if (Plansza[i][j] != NULL)
				Plansza[i][j]->Rysuj();
			else
				cout << "  |";
	}
	
	cout << endl << "    ";
	for (j = 0; j < 18; j++)
			cout << '-';
	
	cout << endl;
}


bool Rozgrywka::Rzut(bool kto)
{
	int i, p, pkt, kon;
	char pion;
	
	cout << "Kostka rzuca zawodnik ";
	if (kto)
		cout << "Lewy." << endl;
	else
		cout << "Prawy." << endl;

	cout << "Ile punktow ? " ;
	cin >> pkt;

	if (pkt < 0 || pkt > 6)
		return false;

	cout << "Ktory pionek? ";
	
	if (kto)
		cout << "[a, b, c, L :] ";
	else
		cout << "[x, y, z, P : ] ";

	cin >> pion;
	pion &= 0x5F;

	if (pion >= 'A' && pion <='C')
	{
		Balony[pion - 'A']->Zmiana(pkt);
		RuchBalonu(pion - 'A');
	}

	if (pion >= 'X' && pion <='Z')
	{
		Balony[pion - 'X' + 3]->Zmiana(pkt);
		RuchBalonu(pion - 'X' + 3);
	}

	if (pion  == 'P')
	{
		Tarcze[0]->Zmiana(pkt);
		RuchTarczy(0);
	}

	if (pion == 'L')
	{
		Tarcze[1]->Zmiana(pkt);
		RuchTarczy(1);
	}

	p = kto ? 0 : 3;
	kon = 0;
	for (i = p; i < p + 3; i++)
		if (Plansza[0][i] != NULL)
			kon++;
	if (kon >= 2)
		return true;
	else
		return false;
}

void Rozgrywka::RuchBalonu(int nr)
{
	Balon* balon = Balony[nr];

	if(balon->Ile() < min_pkt)
	{
		Rysuj();
		return;
	}

	if(	balon->Pozycja.y > 0 &&
		Plansza[(balon->Pozycja.y)-1][balon->Pozycja.x] == NULL)
	{
		Plansza[balon->Pozycja.y][balon->Pozycja.x] = NULL;
		balon->Gora();
		Plansza[balon->Pozycja.y][balon->Pozycja.x] = (Pionek*)balon;
	}

	Rysuj();


}
 
void Rozgrywka::RuchTarczy(int nr)
{
	char kier;
	Tarcza* tarcza = Tarcze[nr];
	
	if (tarcza->Ile() < min_pkt)
	{
		Rysuj();
		return;
	}

	cout << "Podaj kierunek [L,P,G,D] : ";
	cin >> kier;

	switch (kier & 0x5F)
	{
	case 'L' :
		if (tarcza->Pozycja.x == 0 ||
			Plansza[tarcza->Pozycja.y][(tarcza->Pozycja.x)-1] != NULL)
			break;
		else
		{
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = NULL;
			tarcza->Lewo();
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = tarcza;
			break;
		}
	case 'P' :
		if (tarcza->Pozycja.x == 7 ||
			Plansza[tarcza->Pozycja.y][(tarcza->Pozycja.x)+1] != NULL)
			break;
		else
		{
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = NULL;
			tarcza->Prawo();
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = tarcza;
			break;
		}
	case 'G' :
		if (tarcza->Pozycja.y == 1 ||
			Plansza[(tarcza->Pozycja.y)-1][tarcza->Pozycja.x] != NULL)
			break;
		else
		{
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = NULL;
			tarcza->Gora();
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = tarcza;
			break;
		}
	case 'D' :
		if (tarcza->Pozycja.y == 7 ||
			Plansza[tarcza->Pozycja.y][(tarcza->Pozycja.x)+1] != NULL)
			break;
		else
		{
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = NULL;
			tarcza->Dol();
			Plansza[tarcza->Pozycja.y][tarcza->Pozycja.x] = tarcza;
			break;
		}
	}
	
	if (tarcza->Pozycja.y < 7 &&
		Plansza[(tarcza->Pozycja.y)-1][tarcza->Pozycja.x] != NULL)
		Plansza[(tarcza->Pozycja.y)-1][tarcza->Pozycja.x]->Zeruj();
	
	Rysuj();

}

void main()
{
	Rozgrywka Nowa;
	Nowa.Graj();
}