
////  Operowanie Odcinkami ///////


#include "stdafx.h"

#include <iostream>
using namespace std;

#include <math.h>

class Odcinek
{
// dane prywatne

	double Poczatek, Koniec;

public:

// konstruktory

	Odcinek () { };
	Odcinek (double p, double k)
	{
		if (p < k)
		{
			Poczatek = p;
			Koniec = k;
		}
		else
		{
			Poczatek = k;
			Koniec = p;
		}
	}

// funkcje dostpu
	
	double JakiPoczatek ()
	{
		return Poczatek;
	}

	double JakiKoniec ()
	{
		return Koniec;
	}
	
	void UstalPoczatek (double po)
	{
		Poczatek = po;
	}

	void UstalKoniec (double ko)
	{
		Koniec = ko;
	}

// funkcja konwersji

	operator double ()
	{
		return fabs(Koniec - Poczatek) ;
	}

//  przecione operatory 

	friend Odcinek operator + (Odcinek o1, Odcinek o2);
	friend Odcinek operator - (Odcinek o1, Odcinek o2);
	friend Odcinek operator * (Odcinek o1, Odcinek o2);
	friend Odcinek operator / (Odcinek o1, Odcinek o2);

};

Odcinek operator + (Odcinek o1, Odcinek o2)
{
	double p, k;
	p = o1.JakiPoczatek() < o2.JakiPoczatek() ? o1.JakiPoczatek() :
	                                            o2.JakiPoczatek();
	k = o1.JakiKoniec() < o2.JakiKoniec() ? o1.JakiKoniec() :
	                                        o2.JakiKoniec();
	return Odcinek(p, k);
}

Odcinek operator - (Odcinek o1, Odcinek o2)
{
	double p, k;
	p = o1.JakiPoczatek() > o2.JakiPoczatek() ? o1.JakiPoczatek() :
	                                            o2.JakiPoczatek();
	k = o1.JakiKoniec() > o2.JakiKoniec() ? o1.JakiKoniec() :
	                                        o2.JakiKoniec();
	return Odcinek(p, k); 
}

Odcinek operator * (Odcinek o1, Odcinek o2)
{
	double p, k;

	p = o1.JakiPoczatek();
	k = (double)o1 * (double)o2;

	return Odcinek(p, k);
}

Odcinek operator / (Odcinek o1, Odcinek o2)
{
	double p, k;

	if ((double)o2 == 0)
		return o1;

	p = o1.JakiPoczatek();
	k = (double)o1 / (double)o2;

	return Odcinek(p, k);
}



void main( )
{
/*             o1 * (o1 + o2)
		o3 =   ---------------
		           o2 - o1
*/

	double p, k;
	Odcinek o3, o4;

	cout << "\nPodaj poczatek i koniec odcinka o1 : ";
	cin >> p >> k;

	Odcinek	o1(p,k);

	cout << "\nPodaj poczatek i koniec odcinka o2 : ";
	cin >> p >> k;

	Odcinek	o2(p,k);

	o3 = o1 + o2;
	o3 = o1 * o3;
	o4 = o2 - o1;
	o3 = o3 / o4;

	cout << "\nOdcinek o3 : " << o3.JakiPoczatek()
		                      << o3.JakiKoniec() << endl;
}

	

